;Big Clock

video   equ     0A000h

st_seg  segment stack
        db      100h dup  ('THEstack')
st_seg  ends

datarea segment
nyf     dw      0
nymin   dw      00
nymax   dw      100
nmcount db      0
col     db      ?
row     db      ?
y       db      ?
x       db      ?
char    db      ?
tbuff   db      '00000'
year    dw      ?
month   db      ?
day     db      ?
wday    db      ?
hour24  db      ?
hour    db      ?
min     db      ?
sec     db      ?
days    dw      da0,da1,da2,da3,da4,da5,da6
months  dw      mo1,mo2,mo3,mo4,mo5,mo6,mo7,mo8,mo9,mo10,mo11,mo12
da0     db      'SUNDAY : $'
da1     db      'MONDAY : $'
da2     db      'TUESDAY : $'
da3     db      'WEDNESDAY : $'
da4     db      'THURSDAY : $'
da5     db      'FRIDAY : $'
da6     db      'SATURDAY : $'
mo1     db      'JANUARY $'
mo2     db      'FEBRUARY $'
mo3     db      'MARCH $'
mo4     db      'APRIL $'
mo5     db      'MAY $'
mo6     db      'JUNE $'
mo7     db      'JULY $'
mo8     db      'AUGUST $'
mo9     db      'SEPTEMBER $'
mo10    db      'OCTOBER $'
mo11    db      'NOVEMBER $'
mo12    db      'DECEMBER $'

htab    db      ?
vtab    db      ?
vidbuff dw      ?                       ;allocated segment addresses
back    dw      ?
bignum  dw      ?
letters dw      ?
backf   dw      0

wid     dw      ?
len     dw      ?
ylen    dw      ?
daty    dw      ?
datx    dw      ?
vidy    dw      ?
vidx    dw      ?
sprarea dw      ?
sstate  db      ?

prior   dw      24
        dw      minute2,minute1,colon1,hour2,hour1
        dw      colon2,second2,second1
        dw      let1,let2,let3,let4,let5,let6,let7,let8,let9,let10,let11
        dw      let12,let13,let14,let15,let16
sprtab  dw      24
        dw      hour1,hour2,colon1,minute1,minute2,colon2,second1,second2
llll    dw      let1,let2,let3,let4,let5,let6,let7,let8,let9,let10,let11
        dw      let12,let13,let14,let15,let16
;sprite variable format 00  02  04   06   08   10 12 14 16 18     20
;       name1   dw      wid,len,daty,datx,skip, y, x,yf,xf,in/out,sprarea
;               dw      collide,frame,priority,y1,x1,y2,x2...
;                       22      24    26       28 30 32 34
;       name2   dw...
hour1   dw      48,87,000,000,0,098,023,1,0,0,bignum
        dw      0,0,185
        dw      000,000,  000,048,  000,096, 000,144, 000,192, 000,240
        dw      087,000,  087,048,  087,096, 087,144, 087,192, 087,240

hour2   dw      48,87,000,000,0,075,060,1,0,0,bignum
        dw      0,0,162
        dw      000,000,  000,048,  000,096, 000,144, 000,192, 000,240
        dw      087,000,  087,048,  087,096, 087,144, 087,192, 087,240

colon1  dw      18,87,000,000,0,069,116,1,0,0,bignum
        dw      0,0,156,  000,288

minute1 dw      48,87,000,000,0,055,128,1,0,0,bignum
        dw      0,0,142
        dw      000,000,  000,048,  000,096, 000,144, 000,192, 000,240
        dw      087,000,  087,048,  087,096, 087,144, 087,192, 087,240

minute2 dw      48,87,000,000,0,039,169,1,0,0,bignum
        dw      0,0,126
        dw      000,000,  000,048,  000,096, 000,144, 000,192, 000,240
        dw      087,000,  087,048,  087,096, 087,144, 087,192, 087,240

colon2  dw      18,87,000,000,0,040,219,1,0,0,bignum
        dw      0,0,127,  000,288,  107,241, 107,259

second1 dw      48,87,000,000,0,017,229,1,0,0,bignum
        dw      0,0,104
        dw      000,000,  000,048,  000,096, 000,144, 000,192, 000,240
        dw      087,000,  087,048,  087,096, 087,144, 087,192, 087,240

second2 dw      48,87,000,000,0,031,267,1,0,0,bignum
        dw      0,0,118
        dw      000,000,  000,048,  000,096, 000,144, 000,192, 000,240
        dw      087,000,  087,048,  087,096, 087,144, 087,192, 087,240

let1    dw      22,22,000,000,0,155,000,0,0,0,letters
        dw      0,0,177,  0,0
let2    dw      22,22,000,000,0,155,022,0,0,0,letters
        dw      0,0,177,  0,0
let3    dw      22,22,000,000,0,155,044,0,0,0,letters
        dw      0,0,177,  0,0
let4    dw      22,22,000,000,0,155,066,0,0,0,letters
        dw      0,0,177,  0,0
let5    dw      22,22,000,000,0,155,088,0,0,0,letters
        dw      0,0,177,  0,0
let6    dw      22,22,000,000,0,155,110,0,0,0,letters
        dw      0,0,177,  0,0
let7    dw      22,22,000,000,0,155,132,0,0,0,letters
        dw      0,0,177,  0,0
let8    dw      22,22,000,000,0,155,154,0,0,0,letters
        dw      0,0,177,  0,0
let9    dw      22,22,000,000,0,155,176,0,0,0,letters
        dw      0,0,177,  0,0
let10   dw      22,22,000,000,0,155,198,0,0,0,letters
        dw      0,0,177,  0,0
let11   dw      22,22,000,000,0,155,220,0,0,0,letters
        dw      0,0,177,  0,0
let12   dw      22,22,000,000,0,155,242,0,0,0,letters
        dw      0,0,177,  0,0
let13   dw      22,22,000,000,0,155,264,0,0,0,letters
        dw      0,0,177,  0,0
let14   dw      22,22,000,000,0,155,286,0,0,0,letters
        dw      0,0,177,  0,0
let15   dw      22,22,000,000,0,155,308,0,0,0,letters
        dw      0,0,177,  0,0
let16   dw      22,22,000,000,0,155,330,0,0,0,letters
        dw      0,0,177,  0,0

filnam1 db      'bigcl   .bin',0
filnam2 db      'bigclb  .bin',0
filnam3 db      'bigcla  .bin',0
filnam4 db      'bigcl   .txt',0
filnam5 db      'bigcl   .cfg',0
handle  dw      ?
filelen dw      0

key     dw      0
tx      dw      0
ty      dw      0

config  db      4 dup (0)
edate   db      '00-00'
edoff   dw      0
marqoff dw      0
marqdat db      32000 dup (32)
marqend db      '}'
datarea ends

codeseg segment

main    proc    far

        assume  cs:codeseg,ds:datarea

        push    ds                      ;set stack for return to dos
        sub     ax,ax
        push    ax

        mov     ax,ds                   ;point to bottom of program memory
        mov     es,ax                   ;in es for change
        mov     ah,4Ah                  ;release memory to pool
        mov     bx,1000h                ;retaining 64k
        int     21h

        mov     ax,datarea              ;set data segment
        mov     ds,ax

        mov     ah,48h                  ;allocate       VIDBUFF video buffer
        mov     bx,0FA0h                ;64000 bytes
        int     21h
        mov     vidbuff,ax

        mov     ah,48h                  ;allocate       BACK background buffer
        mov     bx,1F40h                ;128000 bytes
        int     21h
        mov     back,ax
        mov     es,ax                   ;init to blue
        mov     di,0
        mov     cx,64000
        mov     ax,9797h
        cld
        rep     stosw

        mov     ah,48h                  ;allocate       letters
        mov     bx,1FA0h                ;64000 bytes    sprites
        int     21h
        mov     letters,ax

        mov     ah,48h                  ;allocate       bignum
        mov     bx,1FA0h                ;64000 bytes    sprites
        int     21h
        mov     bignum,ax

        mov     ax,vidbuff              ;point to video buffer
        mov     es,ax

        mov     dx,offset filnam5       ;load config file
        mov     ah,3Dh
        mov     al,02h
        int     21h
        mov     bx,ax
        
        mov     cx,4                    ;load: 
                                        ;      2 bytes for 12/24 switch
        mov     dx,offset config        ;      1 byte  for zero supression
        mov     ah,3Fh                  ;      1 byte  for am/pm supression 
        int     21h
        mov     ah,3Eh
        int     21h

        mov     dx,offset filnam3       ;load letters
        mov     ah,3Dh
        mov     al,02h
        int     21h
        mov     bx,ax
        mov     cx,64000
        mov     dx,0
        push    ds
        mov     ax,letters
        mov     ds,ax
        mov     ah,3Fh
        int     21h
        pop     ds
        mov     ah,3Eh
        int     21h

        mov     dx,offset filnam1       ;load numbers
        mov     ah,3Dh
        mov     al,02h
        int     21h
        mov     bx,ax
        mov     cx,64000
        mov     dx,0
        push    ds
        mov     ax,bignum
        mov     ds,ax
        mov     ah,3Fh
        int     21h
        pop     ds
        mov     ah,3Eh
        int     21h

        mov     dx,offset filnam2       ;load background
        mov     ah,3Dh
        mov     al,02h
        int     21h
        mov     bx,ax
        mov     cx,64000
        mov     dx,0
        push    ds
        mov     ax,back
        mov     ds,ax
        mov     ah,3Fh
        int     21h
        pop     ds
        mov     ah,3Eh
        int     21h
        push    ds
        push    es
        mov     ax,back
        add     ax,3840
        mov     es,ax
        mov     ax,back
        mov     ds,ax
        mov     cx,32000
        mov     si,0
        mov     di,0
        cld
        rep     movsw
        pop     es
        pop     ds
vidmode:
        mov     al,13h                  ;320x200x256 vga
        mov     ah,0
        int     10h

        mov     ax,video
        mov     es,ax
        mov     di,0
        mov     ax,0
        mov     cx,32000
        cld
        rep     stosw

        call    ddate
m0:
        mov     ax,vidbuff
        mov     es,ax
        push    ds
        mov     ax,back
        add     ax,backf
        add     backf,20
        cmp     backf,3840
        jne     m00
        mov     backf,0
m00:
        mov     ds,ax
        mov     si,0
        mov     di,0
        mov     cx,32000
        cld
        rep     movsw
        pop     ds

        mov     ah,0Bh
        int     21h
        cmp     al,0h
        je      m1
        mov     ah,08h
        int     21h
        jmp     m10
m1:
        mov     ah,2Ch                  ; get dos time
        int     21h
        mov     hour,ch
        mov     hour24,ch
        mov     min,cl
        mov     sec,dh
        call    hourfix
        mov     bx,offset sprtab

        add     bx,2
        push    bx
        mov     bx,[bx]
        mov     ah,0
        mov     al,hour
        mov     cl,10
        div     cl
        mov     cl,ah
        mov     ch,0                    ;cx=hour1
        sal     cx,1
        sal     cx,1
        mov     ah,0                    ;ax=hour2
        sal     ax,1
        sal     ax,1
        mov     [bx+24],ax
        pop     bx
        add     bx,2
        push    bx
        mov     bx,[bx]
        mov     [bx+24],cx

        pop     bx

        add     bx,4                    ;skip colon
        push    bx
        mov     bx,[bx]
        mov     ah,0
        mov     al,min
        mov     cl,10
        div     cl
        mov     cl,ah
        mov     ch,0                    ;cx=minute1
        sal     cx,1
        sal     cx,1
        mov     ah,0                    ;ax=minute2
        sal     ax,1
        sal     ax,1
        mov     [bx+24],ax
        pop     bx
        add     bx,2
        push    bx
        mov     bx,[bx]
        mov     [bx+24],cx
        pop     bx


        add     bx,4                    ;skip colon
        push    bx
        mov     bx,[bx]
        mov     ah,0
        mov     al,sec
        mov     cl,10
        div     cl
        mov     cl,ah
        mov     ch,0                    ;cx=second1
        sal     cx,1
        sal     cx,1
        mov     ah,0                    ;ax=second2
        sal     ax,1
        sal     ax,1
        mov     [bx+24],ax
        pop     bx
        add     bx,2
        push    bx
        mov     bx,[bx]
        mov     [bx+24],cx
        pop     bx


m4:
        call    numov
        call    marquee
        call    prisort
        call    sprite
        call    scrnout                 ;output completed screen frame

        assume  ds:datarea
        mov     ax,datarea
        mov     ds,ax
m5:
;       mov     htab,0
;       mov     vtab,24
;       call    locate
;       mov     dx,numx
;       call    var
;       mov     al,','
;       call    stdout
;       mov     dx,numy
;       call    var
;       mov     al,' '
;       call    stdout
;       call    stdout
;       call    stdout
;       call    stdout
m7:
        mov     al,hour24
        add     al,min
        add     al,sec
        cmp     al,0
        jne     m8
        call    ddate
m8:
        jmp     m0
m10:
        mov     al,03h
        mov     ah,00h
        int     10h     
        ret                             ;to dos

main    endp

hourfix proc    near
        push    ax
        push    bx
        push    si

        mov     si,offset config
      
        mov     bx,offset hour1
        cmp     byte ptr [si+2],'0'
        jne     hf4
        cmp     word ptr [bx+24],0
        jne     hf3
        mov     word ptr [bx+8],1
        jmp     hf4
hf3:
        mov     word ptr [bx+8],0
hf4:
        mov     bx,offset colon2
       
        cmp     byte ptr [si+3],'M'
        je      hf6
        cmp     hour24,11
        jg      hf5
        mov     word ptr [bx+24],8
        jmp     hf7
hf5:    
        mov     word ptr [bx+24],4
        jmp     hf7
hf6:    
        mov     word ptr [bx+24],0
hf7:
        cmp     byte ptr [si],'1'
        jne     hf9
        cmp     hour,0
        jne     hf8
        mov     hour,12
        jmp     hf9
hf8:
        cmp     hour,11
        jng     hf9
        cmp     hour,12
        je      hf9
        sub     hour,12
hf9:
        pop     si
        pop     bx
        pop     ax
        ret
hourfix endp

getmarq proc    near
        mov     dx,offset filnam4       ;load marquee data
        mov     ah,3Dh
        mov     al,02h
        int     21h
        jc      close

        mov     bx,ax
        mov     ah,42h                  ;check filesize
        mov     al,02h                  ;
        mov     cx,0                    ;
        mov     dx,0                    ;
        int     21h                     ;

        jc      close
        cmp     dx,0                    ;certainly not 64k+
        jne     close                   ;
        cmp     ax,32000                ;up to 32000 bytes
        jg      close
        cmp     ax,0
        jl      close
        mov     filelen,ax              ;
        mov     ah,42h                  ;
        mov     al,00h                  ;
        mov     cx,0                    ;
        mov     dx,0                    ;
        int     21h                     ;end check

        mov     dx,marqoff

        mov     cx,filelen
        mov     ah,3Fh
        int     21h

close:  mov     ah,3Eh
        int     21h
        mov     marqoff,2

        call    event
        ret
getmarq endp

event   proc    near
        push    ds
        push    es

        mov     ax,datarea
        mov     ds,ax
        mov     es,ax

        mov     si,offset marqdat
        cld
ev0:
        lodsb
        cmp     al,'}'
        jne     ev0
        mov     di,si
        dec     di
;       mov     al,32
        stosb
        dec     si
        mov     edoff,si

        cld
ev1:
        lodsb

        cmp     al,'|'                  ;EOF chr
        jne     ev2
        mov     si,offset edoff
        jmp     eventexit
ev2:
        cmp     al,'{'
        jne     ev1
        mov     cx,5
        mov     bx,offset edate
ev3:
        lodsb
        cmp     al,[bx]

        je      ev3a
        jmp     ev1
ev3a:
        inc     bx
        loop    ev3

        mov     di,edoff
ev4:
        lodsb
        cmp     al,'}'
        je      e5
        stosb
        jmp     ev4
e5:
        stosb
eventexit:
        mov     al,'}'
        mov     di,si
        stosb
        pop     es
        pop     ds
        ret
event   endp

marquee proc    near
        mov     bx,offset llll
        mov     cx,16
mq1:
        push    bx
        mov     bx,[bx]

        mov     ax,[bx+12]
        sub     ax,8
        cmp     ax,-16
        jnl     mq2
        add     ax,352
        call    getlet
mq2:
        mov     [bx+12],ax

        pop     bx
        add     bx,2
        loop    mq1


        ret
marquee endp

getlet  proc    near
        push    ax
        push    cx
        push    dx
        push    si

        mov     si,offset marqdat
        add     si,marqoff
gl1:
        mov     al,[si]                 ;chr from marqdata
        cmp     al,125                  ;loop if '}' found
        jne     gl2
        mov     si,offset marqdat
        mov     marqoff,0
        mov     al,[si]
gl2:
        cmp     al,10
        jne     gl3
        inc     marqoff
        inc     si
        jmp     gl1
gl3:
        cmp     al,32
        jl      gl4
        cmp     al,96
        jg      gl4
        jmp     gl5
gl4:
        mov     al,32
gl5:
        sub     al,32                   ;- 32 first ascii
        mov     ah,0                    ;just al
        mov     dl,14                   ;divided by 14 graphics chr per line
        div     dl                      ;divide    ah=column  al=row
        mov     dx,ax                   ;save row/column for mult
        mov     al,22
        mul     dl                      ;22*row=y
        mov     [bx+28],ax
        mov     al,22
        mul     dh                      ;22*col=x
        mov     [bx+30],ax

        inc     marqoff
        pop     si
        pop     dx
        pop     cx
        pop     ax
        ret
getlet  endp

ddate   proc    near
        push    es
        mov     ax,datarea
        mov     es,ax
        mov     ah,2Ah
        int     21h
        mov     year,cx
        dec     dh
        mov     month,dh
        mov     day,dl
        mov     wday,al

        mov     di,offset marqdat
        add     di,5

        mov     si,offset days
        mov     al,wday
        mov     ah,0
        shl     ax,1
        add     si,ax
        mov     si,[si]
        cld
dd1:
        lodsb
        cmp     al,'$'
        je      dd2
        stosb
        jmp     dd1
dd2:
        mov     si,offset months
        mov     al,month
        mov     ah,0
        shl     ax,1
        add     si,ax
        mov     si,[si]
        cld
dd3:
        lodsb
        cmp     al,'$'
        je      dd4
        stosb
        jmp     dd3
dd4:

        mov     al,day
        mov     ah,0
        mov     cl,10
        div     cl
        add     ah,48                   ;ones
        add     al,48                   ;tens
        cld
        stosb
        mov     al,ah
        stosb
        mov     al,44
        stosb
        mov     al,32
        stosb

        mov     ax,year
        mov     dx,0
        mov     cx,10
        div     cx
        push    dx                      ;dx = ones
        mov     dx,0
        div     cx
        push    dx                      ;dx = tens
        mov     dx,0
        div     cx
        push    dx                      ;dx = hundreds
        mov     dx,0
        div     cx                      ;dx = thousands
        mov     al,dl
        add     al,48
        stosb
        pop     ax
        add     al,48
        stosb
        pop     ax
        add     al,48
        stosb
        pop     ax
        add     al,48
        stosb
        mov     al,32
        stosb
        stosb
        stosb
        stosb
        stosb
        dec     di
        mov     marqoff,di

        mov     di,offset edate
        mov     al,month
        inc     al
        mov     ah,0
        mov     dl,10
        div     dl
        add     al,48
        mov     [di],al                 ;into edate
        add     ah,48
        mov     [di+1],ah               ;month 1's digit into edate
        mov     al,'-'
        mov     [di+2],al
        mov     al,day
        mov     ah,0
        mov     dl,10
        div     dl
        add     al,48
        mov     [di+3],al               ;into edate
        add     ah,48
        mov     [di+4],ah               ;day 1's digit into edate

        call    getmarq

        pop     es
        ret
ddate   endp

prisort proc    near
        push    bx
        push    cx
        push    dx
        push    si
        push    di

sortstart:
        mov     bx, offset prior
        mov     cx,[bx]                 ;sprite count
        dec     cx                      ;sprite count - 1
        add     bx,2                    ;bx points to first item in list
        mov     sstate,0                ;clear sort state
sort:
        push    bx                      ;save item address pointer

        mov     si,[bx]                 ;si = current item adress
        mov     bx,[bx+2]               ;bx = next item adress

        mov     di,[si+26]              ;priority level of current item
        mov     dx,[bx+26]              ;priority level of next item
        cmp     di,dx
        jng     noswitch

        mov     sstate,1                ;if exchanging, set sort state
        pop     bx                      ;restore item address pointer
        mov     di,[bx]                 ;get address of current item
        mov     dx,[bx+2]               ;get address of next item
        mov     [bx],dx                 ;put next in current
        mov     [bx+2],di               ;put current in next
        jmp     switched
noswitch:
        pop     bx
switched:
        add     bx,2
        loop    sort

        cmp     sstate,0
        je      sortdone
        jmp     sortstart
sortdone:

        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        ret
prisort endp

numov   proc    near
        push    bx
        push    si
        push    di

        inc     nmcount
        cmp     nmcount,60
        je      nm2
        jmp     nmex
nm2:
        mov     nmcount,0

        mov     bx,offset sprtab
        add     bx,2
        mov     cx,8
nm3:
        push    bx
        mov     bx,[bx]
        mov     di,[bx+10]
        mov     ax,[bx+14]
        add     di,ax

        cmp     di,nymin
        jnl     nm4
nm5:
        neg     ax
        mov     [bx+14],ax
        jmp     nm6
nm4:
        cmp     di,nymax
        jng     nm6
        jmp     nm5
nm6:
        mov     di,[bx+10]
        mov     ax,[bx+14]
        add     di,ax
        mov     [bx+10],di
        mov     di,[bx+26]
        add     di,ax
        mov     [bx+26],di
        pop     bx
        add     bx,2
        loop    nm3
nmex:
        pop     di
        pop     si
        pop     bx
        ret
numov   endp

scrnout proc    near                    ;display game frame
        mov     ax,vidbuff
        mov     ds,ax
        mov     ax,video
        mov     es,ax
        mov     si,0
        mov     di,0

        mov     cx,32000
        rep     movsw

        ret
scrnout endp

sprite  proc    near
        assume  ds:datarea
        mov     bx,offset prior
        mov     cx,[bx]                 ;get number of sprites
sprstart:
        push    cx

        add     bx,2
        push    bx
        mov     bx,[bx]                 ;sprite name

        mov     si,[bx+20]              ;segment of video sprite video data
        mov     ax,[si]
        mov     sprarea,ax
        mov     ax,[bx+8]
        cmp     ax,0
        je      frame
        jmp     notmove

frame:  mov     ax,[bx+24]
        mov     si,bx
        add     si,28
        add     si,ax
        mov     ax,[si]
        mov     [bx+4],ax
        mov     ax,[si+2]
        mov     [bx+6],ax
sprwrite:


        mov     si,bx                   ;boundry testing starts
        cld
        lodsw
        mov     wid,ax
        lodsw
        mov     len,ax
        mov     ylen,ax
        lodsw
        mov     daty,ax
        lodsw
        mov     datx,ax
        add     si,2
        lodsw
        mov     vidy,ax
        lodsw
        mov     vidx,ax

bndy:   mov     ax,vidy
        cmp     ax,191
        jng     b00
        jmp     bout                    ;y>191
b00:    add     ax,ylen
        cmp     ax,0
        jg      b0
        jmp     bout                    ;y+len<0
b0:     sub     ax,ylen
        cmp     ax,0
        jnl     b1
        mov     ax,vidy
        sub     daty,ax
        add     ax,ylen
        cmp     ax,0
        mov     len,ax
        mov     ax,0
        mov     vidy,ax
        jmp     bndx                    ;y<0<=y+len
b1:     add     ax,ylen
        cmp     ax,191
        jng     bndx                    ;0<=y<y+len<=191
        mov     ax,191
        sub     ax,vidy
        inc     ax
        mov     len,ax                  ;y<191<y+len
        jmp     bndx
bndx:   mov     ax,vidx
        cmp     ax,319
        jg      bout                    ;x>319
        add     ax,wid
        dec     ax
        cmp     ax,0
        jl      bout                    ;x+wid<0
        sub     ax,wid
        inc     ax
        cmp     ax,0
        jnl     b2
        mov     ax,vidx
        sub     datx,ax
        inc     wid
b3:     add     wid,ax
        dec     wid
        mov     ax,0
        mov     vidx,ax
        jmp     bin                     ;x<0<=x+wid
b2:     add     ax,wid
        cmp     ax,319
        jng     bin                     ;0<=x<x+wid<=319
        mov     ax,319
        sub     ax,vidx
        inc     ax
        mov     wid,ax                  ;x<319<x+wid
bin:    mov     dx,0
        mov     [bx+18],dx
        jmp     bend
bout:   mov     dx,1
        mov     [bx+18],dx
bend:                                   ;end of boundry testing
        cmp     dx,1
        jne     movok
        jmp     notmove
movok:
        mov     si,daty                 ;data start y

        mov     ax,si
        call    yadd
        mov     si,ax
        add     si,datx                 ;total data adress

        mov     di,vidy                 ;video start y

        mov     ax,di
        call    yadd
        mov     di,ax
        add     di,vidx                 ;total video adress

        mov     cx,len                  ;length
sprline:
        push    cx
        mov     cx,wid                  ;width

        push    ds
        mov     ax,sprarea
        mov     ds,ax
        cld
sprrow:
        lodsb                           ;sprite byte
        cmp     al,0
        je      skippit
        stosb                           ;put on screen buffer
        loop    sprrow                  ;next byte
        jmp     sprrowend
skippit:
        inc     di
        loop    sprrow
sprrowend:
        pop     ds
                                        ;line incrementing
        mov     ax,daty                 ;dat line
        add     ax,1
        mov     daty,ax
        call    yadd                    ;y in ax
        mov     si,ax
        add     si,datx                 ;x part

        mov     ax,vidy                 ;vid line
        add     ax,1
        mov     vidy,ax
        call    yadd
        mov     di,ax
        add     di,vidx                 ;x part

        pop     cx
        loop    sprline
notmove:
        pop     bx
        pop     cx
        loop    sprstartbr
        ret
sprstartbr:
        jmp     sprstart
sprite  endp

var     proc    near
        push    di                      ;dx points to var to ?
        push    dx
        push    cx
        push    ax

        mov     cx,0
        lea     di,tbuff
dec16out1:
        push    cx
        mov     ax,dx
        mov     dx,0
        mov     cx,10
        div     cx
        xchg    ax,dx
        add     al,30h
        mov     [di],al
        inc     di

        pop     cx
        inc     cx
        cmp     dx,0
        jnz     dec16out1
dec16out2:
        dec     di
        mov     al,[di]
        call    stdout
        loop    dec16out2

        pop     ax
        pop     cx
        pop     dx
        pop     di
        ret
var     endp

locate  proc    near
        push    ax
        push    bx
        push    dx

        mov     ah,02
        mov     bh,0
        mov     dh,vtab
        mov     dl,htab
        int     10h

        pop     dx
        pop     bx
        pop     ax
        ret
locate  endp

stdout  proc    near
        push    dx
        mov     dl,al
        mov     ah,2
        int     21h
        pop     dx
        ret
stdout  endp

yadd    proc    near
        push    bx                      ;y value in ax
        mov     bl,ah
        mov     bh,al                   ;bx=y*256
        shl     ax,1                    ;*2
        shl     ax,1                    ;*4
        shl     ax,1                    ;*8
        shl     ax,1                    ;*16
        shl     ax,1                    ;*32
        shl     ax,1                    ;*64
        add     ax,bx                   ;ax=y*320
        pop     bx
        ret
yadd    endp

codeseg ends

        end     main
